#ifndef __INCLUDE_USER32_CALLBACK_H
#define __INCLUDE_USER32_CALLBACK_H

#define USER32_CALLBACK_WINDOWPROC          (0)
#define USER32_CALLBACK_SENDASYNCPROC       (1)
#define USER32_CALLBACK_SENDNCCREATE        (2)
#define USER32_CALLBACK_SENDNCCALCSIZE      (3)
#define USER32_CALLBACK_SENDCREATE          (4)
#define USER32_CALLBACK_MAXIMUM             (4)

typedef struct _WINDOWPROC_CALLBACK_ARGUMENTS
{
  WNDPROC Proc;
  HWND Wnd;
  UINT Msg;
  WPARAM wParam;
  LPARAM lParam;
} WINDOWPROC_CALLBACK_ARGUMENTS, *PWINDOWPROC_CALLBACK_ARGUMENTS;

typedef struct _SENDASYNCPROC_CALLBACK_ARGUMENTS
{
  SENDASYNCPROC Proc;
  HWND Wnd;
  UINT Msg;
  ULONG Data;
  LRESULT Result;
} SENDASYNCPROC_CALLBACK_ARGUMENTS, *PSENDASYNCPROC_CALLBACK_ARGUMENTS;

typedef struct _SENDNCCREATEMESSAGE_CALLBACK_ARGUMENTS
{
  HWND Wnd;
  CREATESTRUCT CreateStruct;
} SENDNCCREATEMESSAGE_CALLBACK_ARGUMENTS, 
  *PSENDNCCREATEMESSAGE_CALLBACK_ARGUMENTS;

typedef struct _SENDCREATEMESSAGE_CALLBACK_ARGUMENTS
{
  HWND Wnd;
  CREATESTRUCT CreateStruct;
} SENDCREATEMESSAGE_CALLBACK_ARGUMENTS, *PSENDCREATEMESSAGE_CALLBACK_ARGUMENTS;

NTSTATUS STDCALL
User32CallWindowProcFromKernel(PVOID Arguments, ULONG ArgumentLength);
NTSTATUS STDCALL
User32CallSendAsyncProcForKernel(PVOID Arguments, ULONG ArgumentLength);
NTSTATUS STDCALL
User32SendNCCREATEMessageForKernel(PVOID Arguments, ULONG ArgumentLength);
NTSTATUS STDCALL
User32SendCREATEMessageForKernel(PVOID Arguments, ULONG ArgumentLength);

#endif /* __INCLUDE_USER32_CALLBACK_H */
